<script lang="ts">
	import type { Column } from './table';

	export let columns: Column[];
	export let data: any[];

	const getPathData = (data: any, path: string) => path.split('.').reduce((o, i) => o[i], data);
</script>

<table role="grid">
	<thead>
		<tr>
			{#each columns as column (column.key)}
				<th scope="col">{column.name}</th>
			{/each}
			<slot name="appendColumn" />
		</tr>
	</thead>
	<tbody>
		{#each data as row}
			<tr>
				{#each columns as column (column.key)}
					<td>{getPathData(row, column.key)}</td>
				{/each}
				<slot name="appendColumnData" userId={row.id} />
			</tr>
		{/each}
	</tbody>
</table>
